## libomemo 0.6.2+git20200527.e3b212

=== Makefile ===
### toolchain
#
CC ?= gcc
AR ?= ar
LIBTOOL ?= libtool
MKDIR = mkdir
MKDIR_P = mkdir -p

PKG_CONFIG ?= pkg-config
GLIB_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags glib-2.0)
GLIB_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs glib-2.0)

SQLITE3_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags sqlite3)
SQLITE3_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs sqlite3)

MXML_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags mxml)
MXML_LDFLAGS ?= $(shell $(PKG_CONFIG) --libs mxml)

LIBGCRYPT_CONFIG ?= libgcrypt-config
LIBGCRYPT_LDFLAGS ?= $(shell $(LIBGCRYPT_CONFIG) --libs)

SDIR = src
BDIR = build
TDIR = test
LDIR = lib

# according to https://sourceware.org/bugzilla/show_bug.cgi?id=17879
# -fno-builtin-memset is enough to make gcc not optimize it away
FILES =

PKGCFG_C=$(GLIB_CFLAGS) \
	 $(MXML_CFLAGS) \
	 $(SQLITE3_CFLAGS) \
	 $(LIBGCRYPT_CFLAGS)

PKGCFG_L=$(GLIB_LDFLAGS) \
	 $(MXML_LDFLAGS) \
	 $(SQLITE3_LDFLAGS) \
	 $(LIBGCRYPT_LDFLAGS)

CFLAGS += -std=c11 -Wall -Wextra -Wpedantic -Wstrict-overflow \
		-fno-strict-aliasing -funsigned-char \
		-fno-builtin-memset -g $(PKGCFG_C)
CPPFLAGS += -D_XOPEN_SOURCE=700 -D_DEFAULT_SOURCE
CFLAGS_CONVERSATIONS=$(CFLAGS) -DOMEMO_XMLNS='"eu.siacs.conversations.axolotl"' -DOMEMO_NS_SEPARATOR='"."' -DOMEMO_NS_NOVERSION
COVFLAGS = --coverage -O0 -g $(CFLAGS)
LDFLAGS += -pthread -ldl -lm $(PKGCFG_L)
TESTFLAGS = -lcmocka $(LDFLAGS)

all: $(BDIR)/libomemo-conversations.a

$(BDIR):
	$(MKDIR_P) $@

libomemo: $(SDIR)/libomemo.c libomemo_crypto libomemo_storage $(BDIR)
	$(LIBTOOL) --mode=compile $(CC) -c $(SDIR)/$@.c $(CFLAGS) $(CPPFLAGS) -o $(BDIR)/$@.lo
	$(LIBTOOL) --mode=link $(CC) -o $(BDIR)/$@.la $(BDIR)/$@.lo $(BDIR)/$@_crypto.lo $(BDIR)/$@_storage.lo

libomemo-conversations: $(SDIR)/libomemo.c libomemo_crypto libomemo_storage $(BDIR)
	$(LIBTOOL) --mode=compile $(CC) -c $(SDIR)/libomemo.c $(CFLAGS_CONVERSATIONS) -o $(BDIR)/libomemo.lo
	$(LIBTOOL) --mode=link $(CC) -o $(BDIR)/libomemo.la $(BDIR)/libomemo.lo $(BDIR)/libomemo_crypto.lo $(BDIR)/libomemo_storage.lo

libomemo_crypto: $(SDIR)/libomemo_crypto.c build
	$(LIBTOOL) --mode=compile $(CC) -c $(SDIR)/$@.c $(CFLAGS) $(CPPFLAGS) -o $(BDIR)/$@.lo

libomemo_storage: $(SDIR)/libomemo_storage.c build
	$(LIBTOOL) --mode=compile $(CC) -c $(SDIR)/$@.c $(CFLAGS) $(CPPFLAGS) -o $(BDIR)/$@.lo

$(BDIR)/libomemo.o: $(BDIR) $(SDIR)/libomemo.c $(SDIR)/libomemo.h
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(SDIR)/libomemo.c -o $@

$(BDIR)/libomemo-conversations.o: $(SDIR)/libomemo.c $(BDIR)
	$(CC) -c $(SDIR)/libomemo.c $(CFLAGS_CONVERSATIONS) -fPIC -o $@

$(BDIR)/libomemo_crypto.o: $(SDIR)/libomemo_crypto.c $(BDIR)
	$(CC) -c $(SDIR)/libomemo_crypto.c $(CFLAGS) $(CPPFLAGS) -fPIC -o $@

$(BDIR)/libomemo_storage.o: $(SDIR)/libomemo_storage.c $(BDIR)
	$(CC) -c $(SDIR)/libomemo_storage.c $(CFLAGS) $(CPPFLAGS) -fPIC -o $@

$(BDIR)/libomemo-conversations.a: $(BDIR)/libomemo-conversations.o $(BDIR)/libomemo_crypto.o $(BDIR)/libomemo_storage.o
	$(AR) rcs $@ $^

.PHONY = test_libomemo.o
test_libomemo: $(TDIR)/test_libomemo.c $(SDIR)/libomemo.c
	$(CC) $(COVFLAGS) $<  $(FILES) -o $(TDIR)/$@.o $(TESTFLAGS)
	-$(TDIR)/$@.o
	mv *.g* $(TDIR)

.PHONY: test_crypto
test_crypto: $(TDIR)/test_crypto.c $(SDIR)/libomemo_crypto.c
	$(CC) $(COVFLAGS) $<  $(FILES) -o $(TDIR)/$@.o $(TESTFLAGS)
	-$(TDIR)/$@.o
	mv *.g* $(TDIR)

.PHONY: test_storage
test_storage: $(TDIR)/test_storage.c $(SDIR)/libomemo_storage.c
	$(CC) $(COVFLAGS) $< $(FILES) -o $(TDIR)/$@.o $(TESTFLAGS)
	-$(TDIR)/$@.o
	mv *.g* $(TDIR)

.PHONY: test
test : test_libomemo test_crypto test_storage

.PHONY: coverage
coverage: test
	gcovr -r . --html --html-details -o $@.html
	gcovr -r . -s
	$(MKDIR_P) $@
	mv $@.* $@

.PHONY: clean
clean:
	rm -rf build coverage
	rm -f $(TDIR)/*.sqlite $(TDIR)/*.o $(TDIR)/*.gcno $(TDIR)/*.gcda

=== debian/changelog ===
libomemo (0.6.2+git20200527.e3b212-2pureos+librem5.1) amber-phone; urgency=medium

  * Upload to amber-phone
  * d/control: Use dh12
  * debian/gbp.conf: Adjust to pureos amber
  * debian: Add gitlab-ci

 -- Guido Günther <agx@sigxcpu.org>  Sun, 22 Nov 2020 18:48:28 +0100

libomemo (0.6.2+git20200527.e3b212-2) unstable; urgency=low

  [Evangelos Ribeiro Tzaras]
  * Add 12byte IVs patch for compatibility with other XMPP clients
  * Note the forwarded patches

  [Federico Ceratto]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Mon, 16 Nov 2020 19:36:10 +0100

libomemo (0.6.2+git20200527.e3b212-1) unstable; urgency=medium

  * Initial Debian release (Closes: #926344)

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Wed, 27 May 2020 17:24:35 +0200

=== debian/control ===
Source: libomemo
Section: libs
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders:
 Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
Build-Depends:
 debhelper-compat (= 12),
 libcmocka-dev,
 libgcrypt20-dev,
 libglib2.0-dev,
 libmxml-dev,
 libsqlite3-dev,
 pkg-config,
Standards-Version: 4.5.0
Homepage: https://github.com/gkdr/libomemo
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/libomemo
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/libomemo.git
Rules-Requires-Root: no

Package: libomemo-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libglib2.0-dev,
 libomemo0 (= ${binary:Version}),
 ${misc:Depends},
Description: Library implementing OMEMO (XEP-0384) (development headers)
 OMEMO is an XMPP Extension Protocol (XEP) for secure multi-client
 end-to-end encryption. It is based on Double Ratched and PEP.
 .
 This package contains the development files.

Package: libomemo0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library implementing OMEMO (XEP-0384)
 OMEMO is an XMPP Extension Protocol (XEP) for secure multi-client
 end-to-end encryption. It is based on Double Ratched and PEP.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# version are the first two decimals
SOVERSION := 0.6.2
MAJOR     := $(shell echo ${SOVERSION} | cut -d. -f1)
MINOR     := $(shell echo ${SOVERSION} | cut -d. -f2)
PATCH     := $(shell echo ${SOVERSION} | cut -d. -f3)

LIBFILE=usr/lib/$(DEB_HOST_MULTIARCH)/libomemo
SOFILE=${LIBFILE}.so
AFILE=${LIBFILE}.a

%:
	dh $@

# upstream has no install target
override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
# copy library with version number
	cp build/libomemo.so debian/tmp/${SOFILE}.${SOVERSION}
# copy static library
	cp build/libomemo-conversations.a debian/tmp/${AFILE}
# copy include headers
	mkdir -p debian/tmp/usr/include/libomemo
	cp src/*.h debian/tmp/usr/include/libomemo
# libomemo.pc files has a placeholder for the architecture which needs replacing
	sed "s:[$$]{ARCHITECTURE}:$(DEB_HOST_MULTIARCH):" src/libomemo.pc > build/libomemo.pc
	cp build/libomemo.pc debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

override_dh_link:
	dh_link -plibomemo0 ${SOFILE}.${SOVERSION} ${SOFILE}.${MAJOR}.${MINOR}
	dh_link -plibomemo0 ${SOFILE}.${SOVERSION} ${SOFILE}.${MAJOR}
	dh_link -plibomemo-dev ${SOFILE}.${MAJOR} ${SOFILE}

## libomemo 0.7.0

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,10 @@
 LIBTOOL ?= libtool
 MKDIR = mkdir
 MKDIR_P = mkdir -p
+
+ARCH = $(shell gcc -print-multiarch)
+VER_MAJ = 0
+VERSION = 0.7.0
 
 PKG_CONFIG ?= pkg-config
 GLIB_CFLAGS ?= $(shell $(PKG_CONFIG) --cflags glib-2.0)
@@ -47,7 +51,7 @@
 LDFLAGS += -pthread -ldl -lm $(PKGCFG_L)
 TESTFLAGS = -lcmocka $(LDFLAGS)
 
-all: $(BDIR)/libomemo-conversations.a
+all: $(BDIR)/libomemo-conversations.a shared
 
 $(BDIR):
 	$(MKDIR_P) $@
@@ -57,7 +61,7 @@
 	$(LIBTOOL) --mode=link $(CC) -o $(BDIR)/$@.la $(BDIR)/$@.lo $(BDIR)/$@_crypto.lo $(BDIR)/$@_storage.lo
 
 libomemo-conversations: $(SDIR)/libomemo.c libomemo_crypto libomemo_storage $(BDIR)
-	$(LIBTOOL) --mode=compile $(CC) -c $(SDIR)/libomemo.c $(CFLAGS_CONVERSATIONS) -o $(BDIR)/libomemo.lo
+	$(LIBTOOL) --mode=compile $(CC) -c $(SDIR)/libomemo.c $(CFLAGS_CONVERSATIONS) -o $(BDIR)/libomemo.lo $(CPPFLAGS)
 	$(LIBTOOL) --mode=link $(CC) -o $(BDIR)/libomemo.la $(BDIR)/libomemo.lo $(BDIR)/libomemo_crypto.lo $(BDIR)/libomemo_storage.lo
 
 libomemo_crypto: $(SDIR)/libomemo_crypto.c build
@@ -70,7 +74,7 @@
 	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(SDIR)/libomemo.c -o $@
 
 $(BDIR)/libomemo-conversations.o: $(SDIR)/libomemo.c $(BDIR)
-	$(CC) -c $(SDIR)/libomemo.c $(CFLAGS_CONVERSATIONS) -fPIC -o $@
+	$(CC) -c $(SDIR)/libomemo.c $(CFLAGS_CONVERSATIONS) $(CPPFLAGS) -fPIC -o $@
 
 $(BDIR)/libomemo_crypto.o: $(SDIR)/libomemo_crypto.c $(BDIR)
 	$(CC) -c $(SDIR)/libomemo_crypto.c $(CFLAGS) $(CPPFLAGS) -fPIC -o $@
@@ -80,6 +84,35 @@
 
 $(BDIR)/libomemo-conversations.a: $(BDIR)/libomemo-conversations.o $(BDIR)/libomemo_crypto.o $(BDIR)/libomemo_storage.o
 	$(AR) rcs $@ $^
+
+$(BDIR)/libomemo.so: $(BDIR)
+	$(CC) -shared $(SDIR)/libomemo.c -Wl,-soname,libomemo.so.$(VER_MAJ) \
+		$(SDIR)/libomemo_crypto.c $(SDIR)/libomemo_storage.c \
+		$(LDFLAGS) $(CPPFLAGS) -fPIC -o $@ $(CFLAGS_CONVERSATIONS)
+
+$(BDIR)/libomemo.pc: $(BDIR)
+	echo 'prefix='$(PREFIX) > $@
+	echo 'exec_prefix=$${prefix}' >> $@
+	echo 'libdir=$${prefix}/lib/$(ARCH)' >> $@
+	echo 'includedir=$${prefix}/include' >> $@
+	echo 'Name: libomemo' >> $@
+	echo 'Version: ${VERSION}' >> $@
+	echo 'Description: OMEMO library for C' >> $@
+	echo 'Requires.private: glib-2.0' >> $@
+	echo 'Cflags: -I$${includedir}/libomemo' >> $@
+	echo 'Libs: -L$${libdir} -lomemo' >> $@
+
+shared: $(BDIR)/libomemo.so $(BDIR)/libomemo.pc
+
+install: $(BDIR)
+	install -d $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/pkgconfig/
+	install -m 644 $(BDIR)/libomemo-conversations.a  $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/libomemo.a
+	install -m 644 $(BDIR)/libomemo.so $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/libomemo.so.$(VERSION)
+	install -m 644 $(BDIR)/libomemo.pc $(DESTDIR)/$(PREFIX)/lib/$(ARCH)/pkgconfig/
+	install -d $(DESTDIR)/$(PREFIX)/include/libomemo/
+	install -m 644 $(SDIR)/libomemo_crypto.h $(DESTDIR)/$(PREFIX)/include/libomemo/
+	install -m 644 $(SDIR)/libomemo_storage.h $(DESTDIR)/$(PREFIX)/include/libomemo/
+	install -m 644 $(SDIR)/libomemo.h $(DESTDIR)/$(PREFIX)/include/libomemo/
 
 .PHONY = test_libomemo.o
 test_libomemo: $(TDIR)/test_libomemo.c $(SDIR)/libomemo.c

=== debian/changelog ===
libomemo (0.7.0-1) unstable; urgency=medium

  [Evangelos Ribeiro Tzaras]
  * Update to upstream v0.7.0
  * Remove upstreamed patches

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sun, 06 Dec 2020 13:03:46 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders:
  Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  libcmocka-dev,
  libgcrypt20-dev,
  libglib2.0-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# version are the first two decimals
SOVERSION := 0.7.0
MAJOR     := $(shell echo ${SOVERSION} | cut -d. -f1)
MINOR     := $(shell echo ${SOVERSION} | cut -d. -f2)
PATCH     := $(shell echo ${SOVERSION} | cut -d. -f3)

LIBFILE=usr/lib/$(DEB_HOST_MULTIARCH)/libomemo
SOFILE=${LIBFILE}.so
AFILE=${LIBFILE}.a

%:
	dh $@

# Makefile is not generated, so we need to explicitly set PREFIX variable
override_dh_auto_install:
	PREFIX=/usr dh_auto_install

override_dh_auto_build:
	PREFIX=/usr dh_auto_build

override_dh_link:
	dh_link -plibomemo0 ${SOFILE}.${SOVERSION} ${SOFILE}.${MAJOR}.${MINOR}
	dh_link -plibomemo0 ${SOFILE}.${SOVERSION} ${SOFILE}.${MAJOR}
	dh_link -plibomemo-dev ${SOFILE}.${MAJOR} ${SOFILE}

## libomemo 0.8.1

=== CMakeLists.txt ===
# Copyright (c) 2022 Sebastian Pipping <sebastian@pipping.org>
# Licensed under the GPL v2 or later

cmake_minimum_required(VERSION 3.16.3)

project(omemo
    VERSION
        0.8.1
    # NOTE: Because this^^ version affects shared library filenames,
    #       it needs a major version bump to 1.0.0 already at
    #       the _first ever ABI break_ despite semver rule 4
    #       (https://semver.org/#spec-item-4).
    LANGUAGES
        C
)

include(FindPkgConfig)
include(GNUInstallDirs)


#
# Public configuration
#
option(BUILD_SHARED_LIBS "Build shared libraries (rather than static ones)" ON)
option(OMEMO_INSTALL "Install build artifacts" ON)
option(OMEMO_WITH_TESTS "Build test suite (depends on cmocka)" ON)
if(NOT _OMEMO_HELP)  # hide from "cmake -DOMEMO_HELP=ON -LH ." output
    option(_OMEMO_WARNINGS_AS_ERRORS "(Unofficial!) Turn warnings into errors" OFF)
    option(_OMEMO_WITH_COVERAGE "(Unofficial!) Build with coverage" OFF)
endif()

if(NOT BUILD_SHARED_LIBS)
    # NOTE: If we don't enforce -fPIC for static(!) libraries, we may run into
    #       "[..] relocation R_X86_64_PC32 against symbol [..]" link errors
    #       in dependent projects trying to link a shared library based on
    #       our static library.
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
endif()


#
# Global CPPFLAGS and CFLAGS
#
add_compile_definitions(
    _XOPEN_SOURCE=700
    _DEFAULT_SOURCE
)
add_compile_options(
    -std=c99
    -Wall
    -Wextra
    -Wpedantic
    -Wstrict-overflow
    -fno-strict-aliasing
    -funsigned-char
    -fno-builtin-memset
)

if(_OMEMO_WARNINGS_AS_ERRORS)
    add_compile_options(-Werror)
endif()

if(_OMEMO_WITH_COVERAGE)
    set(_OMEMO_COVERAGE_FLAGS -g -O0 --coverage)
    add_compile_options(${_OMEMO_COVERAGE_FLAGS})
    link_libraries(${_OMEMO_COVERAGE_FLAGS})
endif()


#
# Build dependencies
#
# NOTE: We cannot use "pkg_check_modules([..] IMPORTED_TARGET [..])"
#       because we'd run into a (false positive) CMake error
#       "contains relative path in its INTERFACE_INCLUDE_DIRECTORIES"
#       when using "target_link_libraries([..] PkgConfig::[..])" with msys2.
if(OMEMO_WITH_TESTS)
    pkg_check_modules(CMOCKA REQUIRED "cmocka")
endif()
pkg_check_modules(GLIB REQUIRED "glib-2.0")
pkg_check_modules(GCRYPT REQUIRED "libgcrypt")
pkg_check_modules(MXML REQUIRED "mxml")
pkg_check_modules(SQLITE REQUIRED "sqlite3")


#
# C library
#
file(GLOB _OMEMO_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/src/libomemo*.[ch])
add_library(omemo ${_OMEMO_SOURCES})
target_include_directories(omemo PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>)

if(OMEMO_INSTALL)
    file(GLOB _OMEMO_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/src/libomemo*.h)
    target_include_directories(omemo PUBLIC $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/libomemo>)
    install(FILES ${_OMEMO_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libomemo)
    install(TARGETS omemo EXPORT omemo
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endif()

if(NOT WIN32)
    set_property(TARGET omemo PROPERTY VERSION ${PROJECT_VERSION})
    set_property(TARGET omemo PROPERTY SOVERSION ${PROJECT_VERSION_MAJOR})
    set_property(TARGET omemo PROPERTY NO_SONAME ${NO_SONAME})
endif()


#
# pkg-config/pkgconf file
#
set(_OMEMO_PKGCONF_EXEC_PREFIX ${CMAKE_INSTALL_PREFIX})
set(_OMEMO_PKGCONF_LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})
set(_OMEMO_PKGCONF_INCLUDEDIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(_OMEMO_PKGCONF_PREFIX ${CMAKE_INSTALL_PREFIX})
string(REPLACE ${CMAKE_INSTALL_PREFIX} \${exec_prefix} _OMEMO_PKGCONF_LIBDIR ${_OMEMO_PKGCONF_LIBDIR})
string(REPLACE ${CMAKE_INSTALL_PREFIX} \${prefix} _OMEMO_PKGCONF_EXEC_PREFIX ${_OMEMO_PKGCONF_EXEC_PREFIX})
string(REPLACE ${CMAKE_INSTALL_PREFIX} \${prefix} _OMEMO_PKGCONF_INCLUDEDIR ${_OMEMO_PKGCONF_INCLUDEDIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libomemo.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/libomemo.pc @ONLY)
set_target_properties(omemo PROPERTIES ADDITIONAL_CLEAN_FILES ${CMAKE_CURRENT_BINARY_DIR}/libomemo.pc)

if(OMEMO_INSTALL)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libomemo.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    )
endif()


#
# C test suite
#
if(OMEMO_WITH_TESTS)
    set(_OMEMO_TEST_TARGETS test_crypto test_libomemo test_storage)

    enable_testing()

    foreach(_target ${_OMEMO_TEST_TARGETS})
        add_executable(${_target} ${CMAKE_CURRENT_SOURCE_DIR}/test/${_target}.c)
        target_link_libraries(${_target} PRIVATE omemo)
        add_test(NAME ${_target} COMMAND ${_target})

        if(BUILD_SHARED_LIBS)
            target_compile_options(${_target} PRIVATE ${CMOCKA_CFLAGS})
            target_link_libraries(${_target} PRIVATE ${CMOCKA_LIBRARIES})
        else()
            target_compile_options(${_target} PRIVATE ${CMOCKA_STATIC_CFLAGS})
            target_link_libraries(${_target} PRIVATE ${CMOCKA_STATIC_LIBRARIES})
        endif()
    endforeach()
endif()


#
# External build dependencies
#
foreach(_target omemo ${_OMEMO_TEST_TARGETS})
    if(BUILD_SHARED_LIBS)
        # TODO: Tests should stop depending on gcrypt
        #       once the tests stop including libomemo's .c(!) files
        target_compile_options(${_target} PRIVATE ${GCRYPT_CFLAGS})
        target_link_libraries(${_target} PRIVATE ${GCRYPT_LIBRARIES})

        target_compile_options(${_target} PUBLIC ${GLIB_CFLAGS})
        target_link_libraries(${_target} PUBLIC ${GLIB_LIBRARIES})

        # TODO: Tests should stop depending on mxml
        #       once the tests stop including libomemo's .c(!) files
        target_compile_options(${_target} PRIVATE ${MXML_CFLAGS})
        target_link_libraries(${_target} PRIVATE ${MXML_LIBRARIES})

        target_compile_options(${_target} PRIVATE ${SQLITE_CFLAGS})
        target_link_libraries(${_target} PRIVATE ${SQLITE_LIBRARIES})
    else()
        # TODO: Tests should stop depending on gcrypt
        #       once the tests stop including libomemo's .c(!) files
        target_compile_options(${_target} PRIVATE ${GCRYPT_STATIC_CFLAGS})
        target_link_libraries(${_target} PRIVATE ${GCRYPT_STATIC_LIBRARIES})

        target_compile_options(${_target} PUBLIC ${GLIB_STATIC_CFLAGS})
        target_link_libraries(${_target} PUBLIC ${GLIB_STATIC_LIBRARIES})

        # TODO: Tests should stop depending on mxml
        #       once the tests stop including libomemo's .c(!) files
        target_compile_options(${_target} PRIVATE ${MXML_STATIC_CFLAGS})
        target_link_libraries(${_target} PRIVATE ${MXML_STATIC_LIBRARIES})

        target_compile_options(${_target} PRIVATE ${SQLITE_STATIC_CFLAGS})
        target_link_libraries(${_target} PRIVATE ${SQLITE_STATIC_LIBRARIES})
    endif()
endforeach()


#
# Coverage reporting
#
if(_OMEMO_WITH_COVERAGE)
    add_custom_target(coverage
        COMMAND gcovr -r ${CMAKE_CURRENT_SOURCE_DIR} --html --html-details -o coverage.html
        COMMAND gcovr -r ${CMAKE_CURRENT_SOURCE_DIR} -s
    )
endif()

=== debian/changelog ===
libomemo (0.8.1-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:25:01 +0000

libomemo (0.8.1-3build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:27:22 +0000

libomemo (0.8.1-3) unstable; urgency=medium

  * d/control: Add Breaks/Replaces on libomemo-dev
    which shipped link to shared object

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Sun, 07 May 2023 11:27:30 +0200

libomemo (0.8.1-2) unstable; urgency=medium

  * Team upload.
  * libomemo0: move libomemo.so back to -dev package (Closes: #1034996)

 -- Arnaud Ferraris <aferraris@debian.org>  Sun, 07 May 2023 10:51:51 +0200

libomemo (0.8.1-1) unstable; urgency=medium

  * Use better git-buildpackage defaults
  * Remove obsolete patches
  * Update symbols
  * Add copyright helper script
  * Adjust rules for cmake based build (not Makefiles)
  * Adjust installed files
  * Add cmake build dependency
  * Update copyright
  * Declare compliance with Debian Policy 4.6.1

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Fri, 27 May 2022 08:33:03 +0200

libomemo (0.7.0-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix cross-misbuild: Derive the multiarch triplet from the host CC.
    (Closes: #1003476)

  [ Evangelos Ribeiro Tzaras ]
  * CI: disable aptly
  * d/patches: Unbreak parallel builds

 -- Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>  Thu, 13 Jan 2022 12:03:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: libomemo
 Section: libs
 Priority: optional
-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders:
  Evangelos Ribeiro Tzaras <devrtz-debian@fortysixandtwo.eu>,
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
  libcmocka-dev,
  libgcrypt20-dev,
@@ -12,13 +14,15 @@
  libmxml-dev,
  libsqlite3-dev,
  pkg-config,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/gkdr/libomemo
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/libomemo
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/libomemo.git
 Rules-Requires-Root: no
 
 Package: libomemo-dev
+Breaks: libomemo0 (<= 0.8.1-2)
+Replaces: libomemo0 (<= 0.8.1-2) 
 Section: libdevel
 Architecture: any
 Multi-Arch: same

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libomemo-$1\.tar\.gz/ \
  https://github.com/gkdr/libomemo/tags .*/v?(\d\S+)\.tar\.gz
